color = {}

function color.HSL(h, s, l, a)
    if s<=0 then return l,l,l,a end
    h, s, l = h/256*6, s/255, l/255
    local c = (1-math.abs(2*l-1))*s
    local x = (1-math.abs(h%2-1))*c
    local m,r,g,b = (l-.5*c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end return {(r+m)*255,(g+m)*255,(b+m)*255,a}
end

-- Mulplies r, g, and b with a. This rules out transparent colors which is important in premultiplied mode.
function color.multiplyChannels(r, g, b, a)
   return (r * a)/255, (g * a)/255, (b * a)/255, a
end

-- Function for ImageData:mapPixel. It will give us the image we need for premultiplied.
function color.premultiplyMapPixel(x, y, r, g, b, a)
   return color.multiplyChannels(r, g, b, a)
end

function color.hex2rgb(hex)
    hex = hex:gsub("#","")
    return {tonumber("0x"..hex:sub(1,2)), tonumber("0x"..hex:sub(3,4)), tonumber("0x"..hex:sub(5,6))}
end


color["Red"] = {255,0,0}
color["Green"] = {0,255,0}
color["Blue"] = {0,0,255}
color["Yellow"] = {255,255,0}
color["Purple"] = {255,0,255}
color["Cyan"] = {0,255,255}

color["DarkGreen"] = {0,200,0}

color["Black"] = {0,0,0}
color["Grey25"] = {255*.25,255*.25,255*.25}
color["Grey50"] = {255*.5,255*.5,255*.5}
color["Grey75"] = {255*.75,255*.75,255*.75}
color["White"] = {255,255,255}

color["RetroBlue"] = {156, 184, 179}
color["RetroYellow"] = {239, 237, 206}

--Dark
color["WetAsphalt"] = color.hex2rgb("#34495e")
color["MidnightBlue"] = color.hex2rgb("#2c3e50")

--Light
color["Clouds"] = color.hex2rgb("#ecf0f1")
color["Silver"] = color.hex2rgb("#bdc3c7")

--Medium
color["Concrete"] = color.hex2rgb("#95a5a6")
color["Asbestos"] = color.hex2rgb("#7f8c8d")

--Red
color["Alizarin"] = color.hex2rgb("#e74c3c")
color["Pomegranate"] = color.hex2rgb("#c0392b")

--Orange
color["Carrot"] = color.hex2rgb("#e67e22")
color["Pumpkin"] = color.hex2rgb("#d35400")

--Yellow
color["SunFlower"] = color.hex2rgb("#f1c40f")
color["Orange"] = color.hex2rgb("#f39c12")

--Green
color["Emerland"] = color.hex2rgb("#2ecc71")
color["Nephritis"] = color.hex2rgb("#27ae60")

--Bluegreen
color["Turquoise"] = color.hex2rgb("#1abc9c")
color["GreenSea"] = color.hex2rgb("#16a085")

--Blue
color["PetermannRiver"] = color.hex2rgb("#3498db")
color["BelizeHole"] = color.hex2rgb("#2980b9")

--Purple
color["Amethyst"] = color.hex2rgb("#9b59b6")
color["Wisteria"] = color.hex2rgb("#8e44ad")

