local lgr = love.graphics
local kbd = love.keyboard

floatPoint = {}
function floatPoint:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function floatPoint:setup(v)
	v = v or {}
	self.x = v.x or 0
	self.y = v.y or 0
	self.value = v.value or 0
	self.fade = 2
	self.fadeSpeed = 2
	self.id = v.id or "floater_" .. math.random(10000,99999)
end

function floatPoint:update(dt)
	self.y = self.y - dt * (100 * 0.2)
	self.fade = self.fade - dt * self.fadeSpeed
	if self.fade <= 0 then
		print(self.id, "Dead")
		self.fade = 0
		game.deadFloaterList[#game.deadFloaterList+1] = self.id
	end
end

function floatPoint:draw()
	lgr.push()
	lgr.translate(self.x, self.y)
	lgr.push()
	lgr.scale(0.2)
	lgr.setFont(font["floatpoint"])
	lgr.setColor(255,255,255,255 * math.min(self.fade,1))
	lgr.print(self.value, 0, 0)
	lgr.pop()
	lgr.pop()
end

function destroyFloaters()
	for i = 1, #game.deadFloaterList do
		game.floaters[game.deadFloaterList[i]] = nil
		print("Removing", game.deadFloaterList[i])
	end
end
