local lgr = love.graphics
font = {}

local function loadImageFont( name, img, char, lh )
	local fi = love.graphics.newImage(img)
	fi:setFilter("nearest", "nearest")
	font[name] = love.graphics.newImageFont(fi, char)
	font[name]:setLineHeight(lh)
end

loadImageFont("mono8", "fonts/mono8.png", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 :-!.,\"?<>_()=", 1)
loadImageFont("cga", "fonts/cga.png", " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~", 1.1)
loadImageFont("dialog", "fonts/dialog.png", " abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,!?-+/():;%&`_*#=[]'{}|", .6)
loadImageFont("tiny", "fonts/tiny.png", " 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.-,!:()[]{}<>\"'", .75)

font["title"] = love.graphics.newFont("fonts/Hamburger Heaven.ttf", 600)
font["pause"] = love.graphics.newFont("fonts/Hamburger Heaven.ttf", 300)
font["fatter"] = love.graphics.newFont("fonts/Hamburger Heaven.ttf", 200)
font["status"] = love.graphics.newFont("fonts/lobster.otf", 70)
font["statusbold"] = love.graphics.newFont("fonts/lobster.otf", 70)
font["menu"] = love.graphics.newFont("fonts/lobster.otf", 45)
font["menu_header"] = love.graphics.newFont("fonts/lobster.otf", 45)
font["foodlist"] = love.graphics.newFont("fonts/lobster.otf", 45)
font["foodlistbold"] = love.graphics.newFont("fonts/lobster.otf", 45)
font["smallstat"] = love.graphics.newFont("fonts/Hamburger Heaven.ttf", 40)
font["smallstat"]:setLineHeight(.9)
font["multiplier"] = love.graphics.newFont("fonts/Hamburger Heaven.ttf", 30)
font["floatpoint"] = love.graphics.newFont("fonts/Hamburger Heaven.ttf", 50)

function setFont(f)
	lgr.setFont(font[f])
end

function getFontHeight(f)
	return font[f]:getHeight()
end

function getFontWidth(f, t)
	return font[f]:getWidth(t)
end

function getFontLineHeight(f)
	return font[f]:getLineHeight()
end

function getFontWrap(f, t, w)
	return font[f]:getWrap(t, w)
end

