local timers = {}
local countCount = 0
local count = {}

function timers:create(...)
    local instance = {}
    setmetatable(instance, {__index = self})
    instance:init(...)
    return instance
end
function timers:init(time, func)
	self.time = time
	self.func = func
	self.id = countCount
	self.alive = true
end

function timers:update(dt)
	self.time = self.time - dt
	if self.time <= 0 then
		self:finish()
	end
end

function timers:finish()
	self.func()
	count[self.id] = nil
end

function updateTimers(dt)
	for i, t in pairs(count) do
		t:update(dt)
	end
end

function newTimer(time, func)
	countCount = countCount + 1
	count[countCount] = timers:create(time, func)
	print("Created Timer:", countCount)
	return countCount
end

function isTimerAlive(id)
	return count[id]
end

function checkTimerTime(id)
	return count[id].time
end

function deleteTimer(id)
	print("Deleting Timer:", id)
	-- timers[id].alive = false
	count[id] = nil
end