local lgr = love.graphics

transition = {
	active = false,
	curtime = 0,
	blok = {},
	quadsize = 8
}

function transition.init()
	-- if app.usecanvas then
	-- 	transition.canvas = lgr.newCanvas(DRAW_WIDTH, DRAW_HEIGHT)
	-- 	transition.canvas:setFilter("nearest", "nearest")
	-- 	local h, v = math.ceil(DRAW_WIDTH / transition.quadsize), math.ceil(DRAW_HEIGHT / transition.quadsize)
	-- 	local q = 0
	-- 	for x = 0, h-1 do
	-- 		for y = 0, v-1 do
	-- 			q = q + 1
	-- 			local qx, qy = x * transition.quadsize, y * transition.quadsize
	-- 			local ox, oy = transition.quadsize / 2, transition.quadsize / 2
	-- 			transition.blok[q] = {
	-- 				x = qx + ox,
	-- 				y = qy + oy,
	-- 				rot = 0,
	-- 				rotspeed = math.pi,--x * y / 2,
	-- 				scale = 1,
	-- 				ox = ox,
	-- 				oy = oy,
	-- 				quad = lgr.newQuad(qx, qy, transition.quadsize, transition.quadsize, DRAW_WIDTH, DRAW_HEIGHT)
	-- 			}
	-- 		end
	-- 	end
	-- end
end

function transition.start(dir, kind, time, func, color)
	if transition.active == false then
		transition.init()
		transition.color = color or {0,0,0}
		transition.kind = kind
		-- if app.usecanvas and transition.kind == "bloks" then
		-- 	lgr.setCanvas(transition.canvas)

		-- 	stateDraw()

		-- 	lgr.setCanvas(app.canvas)
		-- else
			if transition.kind == "bloks" then transition.kind = "fade" end
		-- end
		transition.active = true
		transition.dir = dir
		if dir == "in" then
			transition.curtime = 0
		elseif dir == "out" then
			transition.curtime = 1
		end
		transition.func = func or nil
		transition.time = 1 / time
	end
end

function transition.update(dt)
	if transition.active then
		if transition.dir == "in" then
			transition.curtime = transition.curtime + dt * transition.time
			if transition.curtime > 1 then
				transition.curtime = 1
				transition.finish()
			end
		elseif transition.dir == "out" then
			transition.curtime = transition.curtime - dt * transition.time
			if transition.curtime < 0 then
				transition.curtime = 0
				transition.finish()
			end
		end
		if transition.kind == "bloks" then
			for q = 1, #transition.blok do
				transition.blok[q].rot = transition.curtime * transition.blok[q].rotspeed
				transition.blok[q].scale = 1 - transition.curtime
			end
		end
	end
end

function transition.draw()
	local t = transition.curtime
	if transition.kind ~= "fade" then
		if transition.dir == "in" then
			t = easing.outBounce(t, 0, 1, 1)
		else
			t = easing.inBounce(t, 0, 1, 1)
		end
	end
	if t > 0 then
		local c = transition.color
		if transition.kind == "fade" then
			lgr.setColor(c[1],c[2],c[3],255 * t)
			lgr.rectangle("fill", 0, 0, DRAW_WIDTH, DRAW_HEIGHT)
		elseif transition.kind == "toleft" then
			local w = (DRAW_WIDTH * t)
			lgr.setColor(c[1],c[2],c[3],255)
			lgr.rectangle("fill", 0, 0, w, DRAW_HEIGHT)
		elseif transition.kind == "toright" then
			local w = (DRAW_WIDTH * t)
			lgr.setColor(c[1],c[2],c[3],255)
			lgr.rectangle("fill", DRAW_WIDTH - w, 0, w, DRAW_HEIGHT)
		elseif transition.kind == "curtains" then
			local w = ((DRAW_WIDTH / 2) * t)
			lgr.setColor(c[1],c[2],c[3],255)
			lgr.rectangle("fill", 0, 0, w, DRAW_HEIGHT)
			lgr.rectangle("fill", DRAW_WIDTH - w, 0, w, DRAW_HEIGHT)
		elseif transition.kind == "vertcurtains" then
			local h = ((DRAW_HEIGHT / 2) * t)
			lgr.setColor(c[1],c[2],c[3],255)
			lgr.rectangle("fill", 0, 0, DRAW_WIDTH, h)
			lgr.rectangle("fill", 0, DRAW_HEIGHT - h, DRAW_WIDTH, h)
		elseif transition.kind == "bloks" then
			lgr.setColor(c[1],c[2],c[3],255)
			lgr.rectangle("fill", 0, 0, DRAW_WIDTH, DRAW_HEIGHT)
			for q = 1, #transition.blok do
				local qn = transition.blok[q]
				lgr.setColor(255,255,255,255)
				lgr.drawq(transition.canvas, qn.quad, qn.x, qn.y, qn.rot, qn.scale, qn.scale, qn.ox, qn.oy)
			end
		end
	end
end

function transition.finish()
	transition.active = false
	if transition.func then transition.func() end
end

function transition.isActive()
	return transition.active
end
